function ServerCmdBotWarsGUIRefresh(%client) {
	//send all info whatsoever:
		//selected bot
		//bot names
		//weapon/list
		//equipment
		//budget
		//face/list
		//role/list
		//chest/list
		//hand/list
		//feet/list
		//extras list
		//info
		//price
		//echo("refresh");
	if(!isObject(%client.BotWarsData)) {
		%client.BotWarsData = new ScriptObject() {
			botName1 = "Bot 1";
			botName2 = "Bot 2";
			botName3 = "Bot 3";
			botName4 = "Bot 4";
			botName5 = "Bot 5";
			botEquipment1_index = 1;
			botEquipment2_index = 1;
			botEquipment3_index = 1;
			botEquipment4_index = 1;
			botEquipment5_index = 1;
			botEquipment1_1 = $BotWars::Store[cheapestWeapon];
			botEquipment2_1 = $BotWars::Store[cheapestWeapon];
			botEquipment3_1 = $BotWars::Store[cheapestWeapon];
			botEquipment4_1 = $BotWars::Store[cheapestWeapon];
			botEquipment5_1 = $BotWars::Store[cheapestWeapon];
			selectedBot = "0";
			budget = $BotWars::Store[budget] - ($BotWars::Store[cheapestWeapon].price * 5);
			info = "";
		};
		MissionCleanup.remove(%client.BotWarsData);
	}
	commandToClient(%client, 'BotWarsGUIGetData', "selectedbot", %client.BotWarsData.selectedBot);
	for(%i = 1; %i <= 5; %i++) {
		commandToClient(%client, 'BotWarsGUIGetData', "botname", %i, %client.BotWarsData.botName[%i]);
	}
	BotWarsGUISendDrop("weapons", %client);
	if(%client.BotWarsData.selectedBot) commandToClient(%client, 'BotWarsGUIGetData', "selectedweapon", %client.botWarsData.botEquipment[%client.BotWarsData.selectedBot, 1].UIName);
	
	commandToClient(%client, 'BotWarsGUIGetData', "equipment", 0, 0);
	if(%client.botWarsData.selectedBot) {
		for(%i = 2; %i <= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]; %i++) {
			commandToClient(%client, 'BotWarsGUIGetData', "equipment", %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i].uiName,  %i);
		}
	} 	
	
	commandToClient(%client, 'BotWarsGUIGetData', "budget", %client.BotWarsData.budget);
	
	BotWarsGUISendDrop("faces", %client);
	BotWarsGUISendDrop("roles", %client);
	BotWarsGUISendDrop("chests", %client);
	BotWarsGUISendDrop("arms", %client);
	BotWarsGUISendDrop("legs", %client);
	
	if($BotWars::Store[others, index]) {
		commandToClient(%client, 'BotWarsGUIGetData', "others", 0, 0);
		for(%i = 1; %i <= $BotWars::Store[others, index]; %i++) commandToClient(%client, 'BotWarsGUIGetData', "others", $BotWars::Store[others, %i].UIName, %i);
	}
	
	%client.BotWarsData.selecteditem = "";
	commandToClient(%client, 'BotWarsGUIGetData', "info", "", "");
}

function serverCmdBotWarsGUISelectBot(%client, %bot) {
	%bot = mfloor(%bot);
	if(!isObject(%client.BotWarsData) || %bot < 1 || %bot > 5) return;
	%client.BotWarsData.selectedBot = %bot;
	
	ServerCmdBotWarsGUIRefresh(%client);
}

function serverCmdBotWarsGUIResetTeam(%client) {
	if(isObject($botfightgame) && ($botfightgame.teamOwner1 == %client || $botfightgame.teamOwner2 == %client)) {
		commandToClient(%client, 'MessageBoxOK', "ERROR", "Your bots are fighting; you can't modify them now.");
		return;
	}
	commandToClient(%client, 'MessageBoxYesNo', "CONFIRMATION", "Are you sure you want to reset your team?", 'BotWarsGUIResetTeamConfirm');
}

function servercmdBotWarsGUIResetTeamConfirm(%client) {
	if(isObject($botfightgame) && ($botfightgame.teamOwner1 == %client || $botfightgame.teamOwner2 == %client)) {
		commandToClient(%client, 'MessageBoxOK', "ERROR", "Your bots are fighting; you can't modify them now.");
		return;
	}
	%client.botWarsData.delete();
	ServerCmdBotWarsGUIRefresh(%client);
}

function serverCmdBotWarsGUISelectItem(%client, %tag, %id) {
	//%tag = {weapons, equipment, faces, roles, chests, arms, legs, others}
	//%id = number on the list; same as the order we transmitted to them.
	if(%tag !$= "equipment") { //weapon or un-owned
		%selObj = $BotWars::Store[%tag, %id];
		if(!isObject(%selObj)) {
			ServerCmdBotWarsGUIRefresh(%client);
			return;
		}
		%price = %selObj.price;
		if(%client.BotWarsData.selectedBot && %tag !$= "others") {
			for(%i = 1; %i <= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]; %i++) {
				if(%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i].slot $= %tag) %price -= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i].price;
			}
		}
		commandToClient(%client, 'BotWarsGUIGetData', "info", %selObj.description, %price);
		%client.BotWarsData.selecteditem = %tag SPC %id;
	} else {
		%selObj = %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %id];
		if(!isObject(%selObj)) {
			ServerCmdBotWarsGUIRefresh(%client);
			return;
		}
		%price = -%selObj.price;
		commandToClient(%client, 'BotWarsGUIGetData', "info", %selObj.description, %price);
		%client.BotWarsData.selecteditem = %tag SPC %id;
	}
}

function serverCmdBotWarsGUIBuySell(%client)
{
	if(!%client.BotWarsData.selectedBot) {
		commandToClient(%client, 'MessageBoxOK', "ERROR", "You need to select a bot first! (green buttons)");
		return;
	}
	if(isObject($botfightgame) && ($botfightgame.teamOwner1 == %client || $botfightgame.teamOwner2 == %client)) {
		commandToClient(%client, 'MessageBoxOK', "ERROR", "Your bots are fighting; you can't modify them now.");
		return;
	}
	%tag = getword(%client.BotWarsData.selecteditem, 0);
	%id = getword(%client.BotWarsData.selecteditem, 1);
	if(%tag !$= "equipment") {
		%selObj = $BotWars::Store[%tag, %id];
		if(!isObject(%selObj)) {
			ServerCmdBotWarsGUIRefresh(%client);
			return;
		}
		%price = %selObj.price;
		for(%i = 1; %i <= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]; %i++) {
			if(%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i] == %selObj) {
				commandToClient(%client, 'MessageBoxOK', "ERROR", "You already have that on this bot.");
				return;
			}
		}
		if(%tag !$= "others") {
			for(%i = 1; %i <= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]; %i++) {
				if(%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i].slot $= %tag) {
					%price -= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i].price;
					%prev = %i;
				}
			}
		}
		if(%prev) %prevobj = %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %prev];
		if(!BWRestrictionsOK(%client, %selObj, %prevObj)) {
			commandToClient(%client, 'MessageBoxOK', "ERROR", "Either you don't have a required item for the new one, or the old one is required for something else on the bot.");
			ServerCmdBotWarsGUIRefresh(%client);
			return;
		}
		if(%client.BotWarsData.budget < %price && %price > 0) {
			commandToClient(%client, 'MessageBoxOK', "ERROR", "You don't have enough money in the budget!");
			ServerCmdBotWarsGUIRefresh(%client);
			return;
		}
		%client.BotWarsData.budget -= %price;
		if(%prev) %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %prev] = $BotWars::Store[%tag, %id];
		else {
			%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]++;
			%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]] = $BotWars::Store[%tag, %id];
		}
	} else { //selling something in the eq. list
		%selObj = %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %id];
		if(!isObject(%selObj)) {
			ServerCmdBotWarsGUIRefresh(%client);
			return;
		}
		%price = %selObj.price;
		%client.BotWarsData.budget += %price;
		for(%i = %id; %i < %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]; %i++) {
			%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i] = %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i+1];
		}
		%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]--;
	}
	%client.BotWarsData.selecteditem = "";
	ServerCmdBotWarsGUIRefresh(%client);
}

function BotWarsGUISendDrop(%tag, %client) {
	//echo("send drop: " @ %tag);
	if($BotWars::Store[%tag, index]) commandToClient(%client, 'BotWarsGUIGetData', %tag, $BotWars::Store[%tag, 1].UIName, 1);
	else if($BotWars::Store[%tag, index]) commandToClient(%client, 'BotWarsGUIGetData', %tag, "NONE AVAILABLE", false);
	for(%i = 2; %i <= $BotWars::Store[%tag, index]; %i++) commandToClient(%client, 'BotWarsGUIGetData', %tag, $BotWars::Store[%tag, %i].UIName, %i);
}

function BWRestrictionsOK(%client, %new, %old)
{
	for(%i = 1; %i <= %new.restrictionCount; %i++) {
		%res = %new.restriction[%i];
		%restype = getword(%res, 0);
		%resparam = getword(%res, 1);
		switch$(%restype) {
			case "forbid":
				%OK = true;
			case "require":
				%OK = false;
		}
		for(%j = 1; %j <= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]; %j++) {
			if(%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %j].tag $= %resparam) {
				switch$(%restype) {
					case "forbid":
						%OK = false;
					case "require":
						%OK = true;
				}
			}
		}
		if(!%OK) return false;
	}
	//We are allowed to equip the new item. However, we can't UNequip the OLD item until we make sure nothing requires it.
	//We only check param because if we've equipped something forbidden to the old item we have bigger problems at work.
	for(%i = 1; %i <= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, index]; %i++) {
		for(%j = 1; %j <= %client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i].restrictionCount; %j++) {
			%resparam = getword(%client.BotWarsData.botEquipment[%client.botWarsData.selectedBot, %i].restriction[%j], 1);
			if(%resparam $= %old.tag) return false;
		}
	}
	return true;
}