//bot code by Mr. Wallet
//Much is copy-pasted from various other sources, from greekbots to garagegames to who-knows-where.
//Anyway, thanks to everyone that led to this.
datablock PlayerData(PlayerAgileArmor : PlayerStandardArmor)
{
	maxForwardSpeed = 10.5;
	maxSideSpeed = 9;
	maxBackwardSpeed = 6;
	uiName = "Agile Armor (Bot Wars)";
};

datablock PlayerData(PlayerSuperSpeedArmor : PlayerStandardArmor)
{
	maxForwardSpeed = 14;
	maxSideSpeed = 12;
	maxBackwardSpeed = 8;
	uiName = "Super Speed Armor (Bot Wars)";
};

datablock AudioProfile(BWCritHitSound)
{
	description = "AudioClose3D";
	filename = "base/data/sound/breakBrick.wav";
	preload = 1;
};

function bottomchat(%string)
{
	$BottomChat2 = $BottomChat1;
	$BottomChat1 = %string;
	bottomprintall($BottomChat2 NL $BottomChat1, 10, 3);
}

function botfighttimeover()
{
	if(isobject($BotFightGame)) {
		messageall("", "\c6TIME LIMIT REACHED; TIE GAME.");
		endbotfight();
	}
}

function readybotweapons()
{
	for(%i = 0; %i < $botfightgame.numMembers; %i++) {
		%bot = $botfightgame.member[%i];
		if(%bot.tool0) %bot.tool0.onuse(%bot, 1);
	}
}

//setup stuff
function AIPlayer::SetDefaultAppearance(%bot)
{
	if (!isObject(%bot)) return;
	for (%i = 0; $accent[%i] !$= ""; %i++) %bot.hideNode($accent[%i]);
	for (%i = 0; $chest[%i] !$= ""; %i++) %bot.hideNode($chest[%i]);
	for (%i = 0; $hat[%i] !$= ""; %i++) %bot.hideNode($hat[%i]);
	for (%i = 0; $hip[%i] !$= ""; %i++) %bot.hideNode($hip[%i]);
	for (%i = 0; $LArm[%i] !$= ""; %i++) %bot.hideNode($LArm[%i]);
	for (%i = 0; $LHand[%i] !$= ""; %i++) %bot.hideNode($LHand[%i]);
	for (%i = 0; $LLeg[%i] !$= ""; %i++) %bot.hideNode($LLeg[%i]);
	for (%i = 0; $pack[%i] !$= ""; %i++) %bot.hideNode($pack[%i]);
	for (%i = 0; $RArm[%i] !$= ""; %i++) %bot.hideNode($RArm[%i]);
	for (%i = 0; $RHand[%i] !$= ""; %i++) %bot.hideNode($RHand[%i]);
	for (%i = 0; $RLeg[%i] !$= ""; %i++) %bot.hideNode($RLeg[%i]);
	for (%i = 0; $secondPack[%i] !$= ""; %i++) %bot.hideNode($secondPack[%i]);

	%bot.hideNode("headSkin");
	%bot.hideNode("LSki");
	%bot.hideNode("RSki");
	%bot.hideNode("skirtTrimLeft");
	%bot.hideNode("skirtTrimRight");

	%bot.unhidenode("chest");
	%bot.setNodeColor("chest","1 1 1 1");
	%bot.unhidenode("rarm");
	%bot.setNodeColor("rarm", "1 1 1 1");
	%bot.unhidenode("larm");
	%bot.setNodeColor("larm", "1 1 1 1");
	%bot.unhidenode("rhand");
	%bot.setNodeColor("rhand", "1 1 0 1");
	%bot.unhidenode("lhand");
	%bot.setNodeColor("lhand", "1 1 0 1");
	%bot.unhidenode("pants");
	%bot.setNodeColor("pants", "1 1 1 1");
	%bot.unhidenode("rshoe");
	%bot.setNodeColor("rshoe", "0.3 0.3 0.3 1");
	%bot.unhidenode("lshoe");
	%bot.setNodeColor("lshoe", "0.3 0.3 0.3 1");
	//%bot.setDecalName("AAA-None"); too early
	//%bot.setDecalName("Mod-Suit");
	%bot.unhidenode("headskin");
	%bot.setNodeColor("headskin", "1 1 0 1");
	//%bot.setFaceName("smileyCreepy");
}