for(%i = 1; %i <= $BotWars::Store[weapons, index]; %i++) $BotWars::Store[weapons, %i].delete();
for(%i = 1; %i <= $BotWars::Store[roles, index]; %i++) $BotWars::Store[roles, %i].delete();
for(%i = 1; %i <= $BotWars::Store[faces, index]; %i++) $BotWars::Store[faces, %i].delete();
for(%i = 1; %i <= $BotWars::Store[chests, index]; %i++) $BotWars::Store[chests, %i].delete();
for(%i = 1; %i <= $BotWars::Store[arms, index]; %i++) $BotWars::Store[arms, %i].delete();
for(%i = 1; %i <= $BotWars::Store[legs, index]; %i++) $BotWars::Store[legs, %i].delete();
for(%i = 1; %i <= $BotWars::Store[others, index]; %i++) $BotWars::Store[others, %i].delete();

$BotWars::Store[weapons, index] = 0;
$BotWars::Store[roles, index] = 0;
$BotWars::Store[faces, index] = 0;
$BotWars::Store[chests, index] = 0;
$BotWars::Store[arms, index] = 0;
$BotWars::Store[legs, index] = 0;
$BotWars::Store[others, index] = 0;
$BotWars::Store[nonweapons, index] = 0;

$BotWars::Store[weapons, index]++;
$BotWars::Store[weapons, $BotWars::Store[weapons, index]] = new ScriptObject() {
	tag = "pistol";
	uiname = "Gun";
	slot = "weapons";
	price = 1000;
	description = "Boasting accuracy, effectiveness at any range, and a great rate of fire, the standard pistol is a solid choice for any combatant.";
};
if(MissionCleanup.isMember($BotWars::Store[weapons, $BotWars::Store[weapons, index]])) MissionCleanup.remove($BotWars::Store[weapons, $BotWars::Store[weapons, index]]);
$BotWars::Store[weapons, index]++;
$BotWars::Store[weapons, $BotWars::Store[weapons, index]] = new ScriptObject() {
	tag = "rocket";
	slot = "weapons";
	uiname = "Rocket Launcher";
	price = 1100;
	description = "This devastating weapon can one-shot enemies with regularity, or at least deal heavy damage and send them flying. It presents a danger to oneself and one's allies, though, and it has a lengthy reload time (bot will hold the launcher pointing skywards).";
};
if(MissionCleanup.isMember($BotWars::Store[weapons, $BotWars::Store[weapons, index]])) MissionCleanup.remove($BotWars::Store[weapons, $BotWars::Store[weapons, index]]);
$BotWars::Store[weapons, index]++;
$BotWars::Store[weapons, $BotWars::Store[weapons, index]] = new ScriptObject() {
	tag = "sword";
	slot = "weapons";
	uiname = "Sword";
	price = 900;
	description = "The sword is limited to point-blank effectiveness, but it can deal a large amount of damage in a very short time.";
};
if(MissionCleanup.isMember($BotWars::Store[weapons, $BotWars::Store[weapons, index]])) MissionCleanup.remove($BotWars::Store[weapons, $BotWars::Store[weapons, index]]);
$BotWars::Store[weapons, index]++;
$BotWars::Store[weapons, $BotWars::Store[weapons, index]] = new ScriptObject() {
	tag = "akimboguns";
	slot = "weapons";
	uiname = "Guns Akimbo";
	price = 1300;
	description = "What's better than a gun? Two guns! These dual pistols aren't cheap, but they'll make the lucky bot that wields them a force to be reckoned with.";
};
if(MissionCleanup.isMember($BotWars::Store[weapons, $BotWars::Store[weapons, index]])) MissionCleanup.remove($BotWars::Store[weapons, $BotWars::Store[weapons, index]]);
$BotWars::Store[weapons, index]++;
$BotWars::Store[weapons, $BotWars::Store[weapons, index]] = new ScriptObject() {
	tag = "bow";
	slot = "weapons";
	uiname = "Bow";
	price = 750;
	description = "The bow has trouble hitting moving targets at a distance, and has low damage output... but it's dirt cheap! Put that money to use elsewhere.";
};
if(MissionCleanup.isMember($BotWars::Store[weapons, $BotWars::Store[weapons, index]])) MissionCleanup.remove($BotWars::Store[weapons, $BotWars::Store[weapons, index]]);

for(%i = 1; %i <= $BotWars::Store[weapons, index]; %i++)
{
	if(%i == 1 || $BotWars::Store[weapons, %i].price < %lowestprice) {
		%cheapestweapon = $BotWars::Store[weapons, %i];
		%lowestprice = $BotWars::Store[weapons, %i].price;
	}
}
$BotWars::Store[cheapestWeapon] = %cheapestweapon;



$BotWars::Store[roles, index]++;
$BotWars::Store[roles, $BotWars::Store[roles, index]] = new ScriptObject() {
	tag = "medic";
	slot = "roles";
	uiname = "Medic";
	price = 800;
	description = "Medics have the ability to heal allies. If a teammate is wounded, the medic and him will attempt to meet when convenient; when they touch each other, the teammate's health will be fully restored.";
};
if(MissionCleanup.isMember($BotWars::Store[roles, $BotWars::Store[roles, index]])) MissionCleanup.remove($BotWars::Store[roles, $BotWars::Store[roles, index]]);

for(%i = 1; %i <= $BotWars::Store[roles, index]; %i++)
{
	$BotWars::Store[nonweapons, index]++;
	$BotWars::Store[nonweapons, $BotWars::Store[nonweapons, index]] = $BotWars::Store[roles, %i];
}



$BotWars::Store[faces, index]++;
$BotWars::Store[faces, $BotWars::Store[faces, index]] = new ScriptObject() {
	tag = "berserker";
	slot = "faces";
	uiname = "Berserker";
	price = 1000;
	description = "Berserkers are more prone to firing their weapon without lining up the shot carefully. This gives them superior damage output, but can also slightly hurt their accuracy. It cannot be used with the Sword or Rocket Launcher.";
	restrictioncount = 2;
	restriction1 = "forbid rocket";
	restriction2 = "forbid sword";
};
if(MissionCleanup.isMember($BotWars::Store[faces, $BotWars::Store[faces, index]])) MissionCleanup.remove($BotWars::Store[faces, $BotWars::Store[faces, index]]);

for(%i = 1; %i <= $BotWars::Store[faces, index]; %i++)
{
	$BotWars::Store[nonweapons, index]++;
	$BotWars::Store[nonweapons, $BotWars::Store[nonweapons, index]] = $BotWars::Store[faces, %i];
}



$BotWars::Store[chests, index]++;
$BotWars::Store[chests, $BotWars::Store[chests, index]] = new ScriptObject() {
	tag = "armor";
	slot = "chests";
	uiname = "Armor";
	price = 1200;
	description = "Armor reduces all incoming damage by fifty percent.";
};
if(MissionCleanup.isMember($BotWars::Store[chests, $BotWars::Store[chests, index]])) MissionCleanup.remove($BotWars::Store[chests, $BotWars::Store[chests, index]]);

for(%i = 1; %i <= $BotWars::Store[chests, index]; %i++)
{
	$BotWars::Store[nonweapons, index]++;
	$BotWars::Store[nonweapons, $BotWars::Store[nonweapons, index]] = $BotWars::Store[chests, %i];
}




$BotWars::Store[arms, index]++;
$BotWars::Store[arms, $BotWars::Store[arms, index]] = new ScriptObject() {
	tag = "criticalhits";
	slot = "arms";
	uiname = "Autotargeting Reflexors";
	price = 1050;
	description = "Automatically twitches the fingers to target microfracture weaknessess in enemy armor. All hits (even explosions!) have a 33% chance of dealing critical damage. A critical hit deals double damage and sounds like a brick being broken.";
};
if(MissionCleanup.isMember($BotWars::Store[arms, $BotWars::Store[arms, index]])) MissionCleanup.remove($BotWars::Store[arms, $BotWars::Store[arms, index]]);

$BotWars::Store[arms, index]++;
$BotWars::Store[arms, $BotWars::Store[arms, index]] = new ScriptObject() {
	tag = "vampiric";
	slot = "arms";
	uiname = "Vampiric Capacitor";
	price = 1000;
	description = "Siphons energy reserves from opponents to perform maintenance tasks. All damage inflicted will heal the bot's damage for 1/5 of the amount inflicted.";
};
if(MissionCleanup.isMember($BotWars::Store[arms, $BotWars::Store[arms, index]])) MissionCleanup.remove($BotWars::Store[arms, $BotWars::Store[arms, index]]);

$BotWars::Store[arms, index]++;
$BotWars::Store[arms, $BotWars::Store[arms, index]] = new ScriptObject() {
	tag = "fastreload";
	slot = "arms";
	uiname = "Reloading Servo-Motors";
	price = 1100;
	description = "For use exclusively with the Rocket Launcher. This actuator enhancement reduces the reload time of the Rocket Launcher by fifty percent.";
	restrictioncount = 1;
	restriction1 = "require rocket";
};
if(MissionCleanup.isMember($BotWars::Store[arms, $BotWars::Store[arms, index]])) MissionCleanup.remove($BotWars::Store[arms, $BotWars::Store[arms, index]]);

for(%i = 1; %i <= $BotWars::Store[arms, index]; %i++)
{
	$BotWars::Store[nonweapons, index]++;
	$BotWars::Store[nonweapons, $BotWars::Store[nonweapons, index]] = $BotWars::Store[arms, %i];
}



$BotWars::Store[legs, index]++;
$BotWars::Store[legs, $BotWars::Store[legs, index]] = new ScriptObject() {
	tag = "superspeed";
	slot = "legs";
	uiname = "Locomotion Upgrade";
	price = 900;
	description = "Increases running speed on the ground by 100%.";
};
if(MissionCleanup.isMember($BotWars::Store[legs, $BotWars::Store[legs, index]])) MissionCleanup.remove($BotWars::Store[legs, $BotWars::Store[legs, index]]);

$BotWars::Store[legs, index]++;
$BotWars::Store[legs, $BotWars::Store[legs, index]] = new ScriptObject() {
	tag = "superjump";
	slot = "legs";
	uiname = "Pneumatics Upgrade";
	price = 950;
	description = "Increases jump height by 100%.";
};
if(MissionCleanup.isMember($BotWars::Store[legs, $BotWars::Store[legs, index]])) MissionCleanup.remove($BotWars::Store[legs, $BotWars::Store[legs, index]]);

$BotWars::Store[legs, index]++;
$BotWars::Store[legs, $BotWars::Store[legs, index]] = new ScriptObject() {
	tag = "agile";
	slot = "legs";
	uiname = "Hybrid Leg Upgrade";
	price = 950;
	description = "Increases running speed on the ground by 50%, and increases jump height by 50%.";
};
if(MissionCleanup.isMember($BotWars::Store[legs, $BotWars::Store[legs, index]])) MissionCleanup.remove($BotWars::Store[legs, $BotWars::Store[legs, index]]);

for(%i = 1; %i <= $BotWars::Store[legs, index]; %i++)
{
	$BotWars::Store[nonweapons, index]++;
	$BotWars::Store[nonweapons, $BotWars::Store[nonweapons, index]] = $BotWars::Store[legs, %i];
}