//guns are default
$BotParams[standard, idealmindist] = 5;
$BotParams[standard, idealmaxdist] = 20;
$BotParams[bow, aim] = "high";
$BotParams[bow, idealmindist] = 5;
$BotParams[bow, idealmaxdist] = 15;
$BotParams[rocketlauncher, idealmindist] = 10;
$BotParams[sword, movement] = "charge";

$BotParams[none, movement] = "standard";
$BotParams[none, fire] = "normal";

$BotParams[healing, movement] = "charge";
$BotParams[healing, fire] = "passive";
$BotParams[gettinghealed, movement] = "charge";
$BotParams[gettinghealed, fire] = "passive";
$BotParams[reload, movement] = "evade";
$BotParams[reload, fire] = "ready";
$BotParams[breakLoS, movement] = "evade";
$BotParams[breakLoS, fire] = "normal";
$BotParams[findenemy, fire] = "passive";
$BotParams[findenemy, movement] = "wander";


	

// Thought
function AIPlayer::think(%this)
{
	if(!%this.shooting) { //fucking bows won't stop spamming arrows!! I give up.
		%this.setImageTrigger(1, false);
		%this.setImageTrigger(0, false);
	}
	if(%this.dead && !%this.deathshutdown) {
		%this.deathshutdown = true;
		%this.addTask("triggeroff()");
		if(%this.taskcurrent == -1) %this.executeTasks(0);
	}
	if($botspaused || isObject(%this.getControllingClient()) || !isObject(%this.client) || !isObject(%this.client.player) || %this.dead) return;
	
	if(isObject(%this.looking)) {
		%startPos = %this.geteyepoint();
		%endPos = %this.looking.geteyepoint();
		%frontobj = ContainerRayCast(%startPos, %endPos, ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType), %this);
		%frontbrick = ContainerRayCast(%startPos, %endPos, $TypeMasks::FxBrickObjectType);
	} else {
		%startPos = %this.geteyepoint();
		%endPos = vectorAdd(%this.geteyepoint(), vectorscale(%this.geteyevector(), 50));
		%frontobj = ContainerRayCast(%startPos, %endPos, ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType), %this);
		%frontbrick = ContainerRayCast(%startPos, %endPos, $TypeMasks::FxBrickObjectType);
	}
	%Vec = %this.getMuzzleVector(0);
	%startPos = %this.getMuzzlePoint(0);
	%endPos = VectorAdd(%startPos,vectorscale(%Vec,50));
	%muzzleobj = ContainerRayCast(%startPos, %endPos, ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType), %this);
	%endPos = VectorAdd(%startPos,vectorscale(%Vec,-50));
	%rearobj = ContainerRayCast(%startPos, %endPos, ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType), %this);
	%startpos = %this.geteyepoint();
	%brickup = containerRaycast(%startpos, vectoradd(%startpos, "0 0 3"), $TypeMasks::FxBrickObjectType);
	%brickdown = containerRaycast(%startpos, vectoradd(%startpos, "0 0 -10"), $TypeMasks::FxBrickObjectType);
	%topP = %this.getTopPriority();
	
	if(%this.moving == 0 && %topP !$= "reload") %this.playthread(0, "root");
	
	%this.MotivationCheck(%frontobj, %frontbrick, %muzzleobj, %brickup, %topP);
	
	%this.ConsiderSpecialActions(%frontobj, %frontbrick, %muzzleobj, %brickup, %topP);
	
	%this.thinkabouttarget(%frontobj, %frontbrick, %muzzleobj, %brickup, %topP);
	%this.thinkaboutfiring(%frontobj, %frontbrick, %muzzleobj, %brickup, %topP);
	%this.thinkaboutmoving(%frontobj, %frontbrick, %muzzleobj, %brickup, %topP);
	
	%this.setmovex(%this.movex);
	%this.setmovey(%this.movey);
	if(%this.taskcurrent == -1) %this.executeTasks(0);
	%firingcone = mDegToRad(5 + %this.aimFail);
	%this.setAimLocation(getInaccuratePoint(%this.getEyePoint(), %this.targetPoint, %firingcone));
	%this.schedule(100, think);
}

function AIPlayer::ConsiderSpecialActions(%this, %frontobj, %frontbrick, %muzzleobj, %brickup, %topP)
{
	if(%this.getdamagelevel() && !%this.mediccalled && %this.hasMedicTeamMate()) {
		//%rnd = getrandom(1, 100);
		//if(%rnd > mfloor(%this.getdamagelevel() - 50)) %this.CallForMedic();
		%this.CallForMedic();
	}
	
	if(%topP $= "findenemy") {
		if(%this.findEnemy()) %this.submotivation("findenemy");
	}
	
	if(%this.isMedic) {
		//%rnd = getrandom(-5, 3);
		if(%frontobj != %this.looking || !%this.looking) { //if(%rnd > 0 && %frontobj != %this.looking) {
			%ct = 0;
			InitContainerRadiusSearch(%this.getposition(), 30, $TypeMasks::PlayerObjectType);
			while ((%search = containerSearchNext()) != 0 ) {
				if(%search != %this) {
					if(isObject(%search.looking)) {
						%start = %search.geteyepoint();
						%end = %search.looking.geteyepoint();
						%potential = ContainerRayCast(%start, %end, $TypeMasks::PlayerObjectType, %this);
					} else %hesnotlooking = true;
					if(%search.team == %this.team && containerSearchCurrRadiusDist() <= (%rnd * 5) && (%potential.dead || %this.team == %potential.team || %potential != %search.looking || %hesnotlooking) && %search.medicCalled && !isObject(%search.healer)) {
						%start = %this.geteyepoint();
						%end = %search.geteyepoint();
						%sight = ContainerRayCast(%start, %end, ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType), %this);
						if(%sight == %search) {
							%ct++;
							%targets[%ct] = %search;
							%score[%ct] = 100 + getrandom(0, 50);
							%score[%ct] /= containerSearchCurrRadiusDist();
						}
					} else if(%search.team != %this.team && %search.getmountedimage(0) == nametoID(rocketLauncherImage)) {
						%ohnoesarocket = true;
					}
				}
			}
			if(isobject(%targets[1]) && !%ohnoesarocket) {
				for(%i = 1; %i <= %ct; %i++) {
					if(%score[%i] > %maxscore) {
						%maxscore = %score[%i];
						%winner = %i;
					}
				}
				%this.looking = %targets[%winner];
				//%this.healtarget = %targets[%winner];
				%this.subMotivation("findenemy");
				%this.AddMotivation("healing", 101);
				%this.emote(hateimage);
				%targets[%winner].healer = %this;
				%targets[%winner].looking = %this;
				%targets[%winner].AddMotivation("gettinghealed", 101);
				//%this.looking = %targets[getrandom(1, %ct)];
			}
		}
	}
}

function AIPlayer::ThinkAboutTarget(%this, %frontobj, %frontbrick, %muzzleobj, %brickup, %topP)
{
	switch$($BotParams[%topP, fire]) {
		case "normal":
			if(%muzzleobj.team && %muzzleobj.team != %this.team) {
				if(%muzzleobj != %this.looking && %this.retargetdesire >= 20 / (getdistance(%this, %this.looking) / getdistance(%this, %muzzleobj))) {
					%this.looking = %muzzleobj;
					%this.retargetdesire = 0;
					%this.retargetdist = 0;
				}
				%this.retargetdesire -= 2;
				%this.retargetdist -= 2.25;
				if(%this.retargetdist < 0) %this.retargetdist = 0;
				if(%this.retargetdist > getdistance(%this, %this.looking)) %this.retargetdist = getdistance(%this, %this.looking);
			} else {
				%this.retargetdesire += 1;
				if(%this.lookingatfeetsky(%frontobj, %brickdown)) %this.retargetdesire++;
				%this.addTask("triggeroff()");
				if(%this.weapon $= "sword") %this.retargetdist += 0.5;
				else %this.retargetdist += 1.75;
			}
			if(%this.retargetdesire >= 20 && %this.retargetdist >= getdistance(%this, %this.looking)) {
				if(!%this.FindEnemy()) {
					%this.addMotivation("findenemy", 100);
					%this.findRandomDestination(%brickup);
				}
			}
			if(isObject(%this.looking) && !%this.looking.dead) {
				%x = getWord(%this.looking.getEyePoint(), 0);
				%y = getWord(%this.looking.getEyePoint(), 1);
				%z = getWord(%this.looking.getEyePoint(), 2) - 0.5;
				%rot = getWords(%this.looking.getEyePoint(), 3, 6);
				%this.targetpoint = %x SPC %y SPC (%z - ($BotParams[%this.weapon, aim] $= "high" ? 0 : 0.25)) SPC %rot;
			} else {
				%this.looking = "";
				%this.retargetdist = 100;
				if(!%this.FindEnemy()) {
					if(getrandom(1,10) == 10 && %this.minigame.TeamIsDead(3 - %this.team)) {
						%rnd = getrandom(1, 4);
						switch(%rnd) {
							case 1:
								%txt = "Come out, come out, wherever you are...";
							case 2:
								%txt = "Fight me, you coward!";
							case 3:
								%txt = "Where did you go?!";
							case 4:
								%txt = "When I find you I'm gonna feed you your own shoes!";
						}
						bottomchat(((%this.team == 2) ? "\c0" : "\c1") @ %this.name @ "\c6:" SPC %txt);
					}
					%this.addMotivation("findenemy", 100);
					%this.findRandomDestination(%brickup);
				}
			}
		case "passive":
			if(isObject(%this.looking)) { //teammate action
				%x = getWord(%this.looking.getEyePoint(), 0);
				%y = getWord(%this.looking.getEyePoint(), 1);
				%z = getWord(%this.looking.getEyePoint(), 2) - 0.5;
				%rot = getWords(%this.looking.getEyePoint(), 3, 6);
				%this.targetPoint = %x SPC %y SPC (%z - 0.25) SPC %rot;
				if(%topP $= "healing" && %frontobj == %this.looking && getdistance(%this, %this.looking) < 4) {
					%this.looking.setdamagelevel(0);
					%this.looking.emote(loveimage);
					%this.looking.mediccalled = false;
					if(getrandom(0, 1)) {
						%rnd = getrandom(1, 5);
						switch(%rnd) {
							case 1: %txt = "Thanks medic!";
							case 2: %txt = "Ahh, that's the stuff.";
							case 3: %txt = "I owe you one, " @ %this.name @ "!";
							case 4: %txt = "Wow, I feel much better, thanks!";
							case 5: %txt = "Yay for medics!";
						}
						bottomchat(((%this.team == 2) ? "\c0" : "\c1") @ %this.looking.name @ "\c6:" SPC %txt);
					}
					%this.looking.submotivation("gettinghealed");
					%this.looking.retargetdist = 100;
					if(!%this.looking.FindEnemy()) {
						%this.looking.addMotivation("findenemy", 100);
						%this.findRandomDestination(%brickup);
					}
				} 
			} else {
				if(%this.weapon $= "sword") %this.retargetdist += 0.5;
				else %this.retargetdist += 1.75;
				if(!%this.findEnemy()) {
					if((getrandom(1, 30) == 30 || pointdistance(%this.geteyepoint(), (getwords(%this.getaimlocation(), 0, 2) SPC getword(%this.geteyepoint(), 2))) < 6 || %this.lookingatfeetsky(%frontobj, %brickdown)) && !%this.wanderspam) {
						%this.findRandomDestination(%brickup);
						%this.wanderspam = true;
						%newdist = pointdistance(%this.geteyepoint(), (getwords(%this.getaimlocation(), 0, 2) SPC getword(%this.geteyepoint(), 2)));
						if(%newdist > 6) %newdist = 6;
						else if(%newdist < 2) %newdist = 2;
						%wandertimer = 1250 - (125 * (6 - %newdist)); //500-1000
						schedule(%wandertimer, 0, "nowanderspam", %this);
					}
				}
			}
		case "ready":
			if(%muzzleobj.team && %muzzleobj.team != %this.team) {
				if(%muzzleobj != %this.looking && %this.retargetdesire >= 20 / (getdistance(%this, %this.looking) / getdistance(%this, %muzzleobj))) {
					%this.looking = %muzzleobj;
					%this.retargetdesire = 0;
					%this.retargetdist = 0;
				}
				%this.retargetdesire -= 2;
				%this.retargetdist -= 2.25;
				if(%this.retargetdist < 0) %this.retargetdist = 0;
				if(%this.retargetdist > getdistance(%this, %this.looking)) %this.retargetdist = getdistance(%this, %this.looking);
			} else {
				%this.retargetdesire += 1;
				%this.retargetdist += 1.75;
				if(%this.lookingatfeetsky(%frontobj, %brickdown)) %this.retargetdesire++;
			}
			if(%this.retargetdesire >= 20 && %this.retargetdist >= getdistance(%this, %this.looking)) {
				if(!%this.FindEnemy()) {
					%this.addMotivation("findenemy", 100);
					%this.findRandomDestination(%brickup);
				}
			}
			if(isObject(%this.looking) && !%this.looking.dead) {
				%x = getWord(%this.looking.getEyePoint(), 0);
				%y = getWord(%this.looking.getEyePoint(), 1);
				%z = getWord(%this.looking.getEyePoint(), 2);
				%rot = getWords(%this.looking.getEyePoint(), 3, 6);
				%this.targetPoint = %x SPC %y SPC (%z - ($BotParams[%this.weapon, aim] $= "high" ? 0 : 0.75)) SPC %rot;
			} else {
				%this.looking = "";
				%this.retargetdist = 100;
				if(!%this.FindEnemy()) {
					%this.addMotivation("findenemy", 100);
					%this.findRandomDestination(%brickup);
				}
			}
	}
}

function AIPlayer::ThinkAboutFiring(%this, %frontobj, %frontbrick, %muzzleobj, %brickup, %topP)
{
	//aimconfidence is our confidence to hit the target. twitch is how much we are panicking.
	//being surprised and taking damage increases twitch, which degenerates over time. Having a good aim increases aimconfidence.
	switch$($BotParams[%topP, fire]) {
		case "normal":
			%this.twitch -= 5;
			if(%this.twitch < 0) %this.twitch = 0;
			if(%frontobj != %this.looking) %this.aimConfidence -= 5;
			if(%this.aimConfidence < 0) %this.aimConfidence = 0;
			if(%frontobj == %this.looking) %this.aimFail--;
			else %this.aimFail++;
			if(%this.aimFail < 0) %this.aimFail = 0;
			else if(%this.aimFail > 15) %this.aimFail = 15;
			if(isobject(%this.looking) && !%this.looking.dead) {
				if(%muzzleobj.team && %muzzleobj.team != %this.team) {
					if(%this.weapon $= "rocketlauncher") {
						%this.aimConfidence += 50;
						if(getdistance(%this, %muzzleobj) < 3) {
							%this.aimConfidence -= 15;
							%this.twitch += 20;
						} else if(getdistance(%this, %muzzleobj) < 6) {
							%this.twitch += 5;
						}
					} else if(%this.getmountedimage(0) != nametoID(swordImage)) {
						%this.aimConfidence += 50;
						if(getdistance(%this, %muzzleobj) < 3) {
							%this.twitch += 20;
						} else if(getdistance(%this, %muzzleobj) < 6) {
							%this.twitch += 5;
						}
					}
				}
				if(%this.weapon $= "rocketlauncher") {
					if((%this.aimConfidence * (%this.berserker+1)) + %this.twitch >= getrandom(50,150) && !%this.getpriority("reload")) {
						%firing = true;
						%this.reloadtime = %this.weaponreload;
						%this.addTask("wait(30)");
						%this.firegun();
						%this.addTask("reload()");
						%this.addmotivation("reload", 103);
					}
				} else if(%this.getmountedimage(0) != nametoID(swordImage)) {
					if((%this.aimConfidence * (%this.berserker+1)) + %this.twitch >= getrandom(50,150) && !%this.getpriority("reload")) {
						%firing = true;
						%this.reloadtime = %this.weaponreload;
						%this.firegun();
						%this.addmotivation("reload", 103);
					}
				} else if(getdistance(%this, %this.looking) < 6) { //sword
					%firing = true;
					%this.firegun();
				}
				if(!%firing) {
					%this.addTask("triggeroff()");
				}
			} else {
				%this.looking.retargetdist = 100;
				if(!%this.FindEnemy()) {
					%this.addMotivation("findenemy", 100);
					%this.findRandomDestination(%brickup);
				}
			}
		default:
			%this.addTask("triggeroff()");	
	}
}

function AIPlayer::ThinkAboutMoving(%this, %frontobj, %frontbrick, %muzzleobj, %brickup, %topP)
{
	if($BotParams[%topP, movement] $= "standard" && $BotParams[%this.weapon, movement] !$= "") %movement = $BotParams[%this.weapon, movement];
	else if($BotParams[%topP, movement] !$= "") %movement = $BotParams[%topP, movement];
	else %movement = "standard";
	if($BotParams[%this.weapon, idealmindist] !$= "") %idealmindist = $BotParams[%this.weapon, idealmindist];
	else %idealmindist = $BotParams[standard, idealmindist];
	if($BotParams[%this.weapon, idealmaxdist] !$= "") %idealmaxdist = $BotParams[%this.weapon, idealmaxdist];
	else %idealmaxdist = $BotParams[standard, idealmindist];
	
	switch$(%movement) {
		case "standard":
			switch(%this.moving) {
				case 0:
					if(getrandom(1,10) == 10 || %this.getmountedimage(0) == nametoID(swordImage)) {
						%this.moving = 1;
						%rnd = getrandom(1, 8);
						if(%rnd == 1 || %rnd == 2 || %rnd == 8) %this.movey = 1;
						if(%rnd == 2 || %rnd == 3 || %rnd == 4) %this.movex = 1;
						if(%rnd == 4 || %rnd == 5 || %rnd == 6) %this.movey = -1;
						if(%rnd == 6 || %rnd == 7 || %rnd == 8) %this.movex = -1;
					}
				case 1:
					if(getrandom(1,20) == 20 && %this.getmountedimage(0) != nametoID(swordImage)) {
						%rnd = getrandom(1, 8);
						if(%rnd == 1 || %rnd == 2 || %rnd == 8) %this.movey = 1;
						if(%rnd == 2 || %rnd == 3 || %rnd == 4) %this.movex = 1;
						if(%rnd == 4 || %rnd == 5 || %rnd == 6) %this.movey = -1;
						if(%rnd == 6 || %rnd == 7 || %rnd == 8) %this.movex = -1;
					} else if(getrandom(1,100) == 100) {
						%this.moving = 0;
						%this.movex = 0;
						%this.movey = 0;
					}
			}
			if(isobject(%this.looking)) {
				if(getdistance(%this, %this.looking) > %idealmaxdist) {
					if(getdistance(%this, %frontbrick) > 3) {
						if(%this.movey == 0) %this.movey = 1;
						if(%this.movey == -1) %this.movey = 0;
						if(%this.movey != 0) %this.moving = true;
						else if(%this.movex == 0) %this.moving = false;
					}
				//fix later to try and path around walls behind us
				} else if(getdistance(%this, %this.looking) < %idealmindist) {
					if(!%frontobj.team && %this.moving && getdistance(%this, %rearobj) < 3 && getdistance(%this, %this.looking) > getdistance(%this, %rearobj)) {
						%vel = %this.getvelocity();
						%x = getword(%vel, 0);
						%y = getword(%vel, 1);
						%z = getword(%vel, 2);
						%vel = msqrt((%x * %x) + (%y * %y) + (%z * %z));
						if(%vel < 2) {
							%rnd = getrandom(1, 5);
							if(%rnd <= 2) %this.movex = 1;
							if(%rnd >= 4) %this.movex = -1;
							if(%rnd != 1 && %rnd != 5) %this.movey = -1;
							%this.moving = true;
						}
					} else {
						%this.moving = 1;
						%this.movey = -1;
					}
				}
			}
			if(!%frontobj.team && %this.moving && getdistance(%this, %frontobj) < 3) {
				%vel = %this.getvelocity();
				%x = getword(%vel, 0);
				%y = getword(%vel, 1);
				%z = getword(%vel, 2);
				%vel = msqrt((%x * %x) + (%y * %y) + (%z * %z));
				if(%vel < 2) {
					%rnd = getrandom(1, 5);
					if(%rnd <= 2) %this.movex = 1;
					if(%rnd >= 4) %this.movex = -1;
					if(%rnd != 1 && %rnd != 5) %this.movey = -1;
					%this.moving = true;
				}
			}
			if(!isObject(%brickup)) {
				if(%frontobj == %this.looking && getrandom(1, 30) == 30) %this.jump();
				else if(isobject(%this.looking) && %muzzleobj != %this.looking && getword(%this.looking.getposition(), 2) - 2.3565 > getword(%this.getposition(), 2)) %this.jump();
			}
		case "charge":
			switch(%this.moving) {
				case 0:
					if(getrandom(1,10) == 10 || %this.getmountedimage(0) == nametoID(swordImage)) {
						%this.moving = 1;
						%rnd = getrandom(1, 8);
						if(%rnd == 1 || %rnd == 2 || %rnd == 8) %this.movey = 1;
						if(%rnd == 2 || %rnd == 3 || %rnd == 4) %this.movex = 1;
						if(%rnd == 4 || %rnd == 5 || %rnd == 6) %this.movey = -1;
						if(%rnd == 6 || %rnd == 7 || %rnd == 8) %this.movex = -1;
					}
				case 1:
					if(getrandom(1,20) == 20 && %this.getmountedimage(0) != nametoID(swordImage)) {
						%rnd = getrandom(1, 8);
						if(%rnd == 1 || %rnd == 2 || %rnd == 8) %this.movey = 1;
						if(%rnd == 2 || %rnd == 3 || %rnd == 4) %this.movex = 1;
						if(%rnd == 4 || %rnd == 5 || %rnd == 6) %this.movey = -1;
						if(%rnd == 6 || %rnd == 7 || %rnd == 8) %this.movex = -1;
					} else if(getrandom(1,100) == 100) {
						%this.moving = 0;
						%this.movex = 0;
						%this.movey = 0;
					}
			}
			if(%this.movey == 0 && getrandom(0,1)) %this.movey = 1;
			if(%this.movey == -1 && getrandom(0,1)) %this.movey = 0;
			if(%this.movey != 0) %this.moving = true;
			else if(%this.movex == 0) %this.moving = false;
			if(isObject(%this.looking) && getdistance(%this, %this.looking) < 14 && %frontobj == %this.looking) %this.movey = 1;
			if(!%frontobj.team && %this.moving && getdistance(%this, %frontobj) < 5) {
				%vel = %this.getvelocity();
				%x = getword(%vel, 0);
				%y = getword(%vel, 1);
				%z = getword(%vel, 2);
				%vel = msqrt((%x * %x) + (%y * %y) + (%z * %z));
				if(%vel < 2) {
					%rnd = getrandom(1, 5);
					if(%rnd <= 2) %this.movex = 1;
					if(%rnd >= 4) %this.movex = -1;
					if(%rnd != 1 && %rnd != 5) %this.movey = -1;
					%this.moving = true;
				}
			}
			if(!isObject(%brickup)) {
				if(%frontobj == %this.looking && getrandom(1, 30) == 30) %this.jump();
				else if(isobject(%this.looking) && %muzzleobj != %this.looking && getword(%this.looking.getposition(), 2) - 2.3565 > getword(%this.getposition(), 2)) %this.jump();
			}
		case "evade":
			switch(%this.moving) {
				case 0:
					if(getrandom(1,10) == 10 || %this.getmountedimage(0) == nametoID(swordImage)) {
						%this.moving = 1;
						%rnd = getrandom(1, 8);
						if(%rnd == 1 || %rnd == 2 || %rnd == 8) %this.movey = 1;
						if(%rnd == 2 || %rnd == 3 || %rnd == 4) %this.movex = 1;
						if(%rnd == 4 || %rnd == 5 || %rnd == 6) %this.movey = -1;
						if(%rnd == 6 || %rnd == 7 || %rnd == 8) %this.movex = -1;
					}
				case 1:
					if(getrandom(1,20) == 20 && %this.getmountedimage(0) != nametoID(swordImage)) {
						%rnd = getrandom(1, 8);
						if(%rnd == 1 || %rnd == 2 || %rnd == 8) %this.movey = 1;
						if(%rnd == 2 || %rnd == 3 || %rnd == 4) %this.movex = 1;
						if(%rnd == 4 || %rnd == 5 || %rnd == 6) %this.movey = -1;
						if(%rnd == 6 || %rnd == 7 || %rnd == 8) %this.movex = -1;
					} else if(getrandom(1,100) == 100) {
						%this.moving = 0;
						%this.movex = 0;
						%this.movey = 0;
					}
			}
			
			//fix later to try and path around walls behind us
			//if closer than 20, move backwards
			if(isobject(%this.looking) && getdistance(%this, %this.looking) < 20) {
				if(!%frontobj.team && %this.moving && getdistance(%this, %rearobj) < 5 && getdistance(%this, %this.looking) > getdistance(%this, %rearobj)) {
					%vel = %this.getvelocity();
					%x = getword(%vel, 0);
					%y = getword(%vel, 1);
					%z = getword(%vel, 2);
					%vel = msqrt((%x * %x) + (%y * %y) + (%z * %z));
					if(%vel < 2) {
						%rnd = getrandom(1, 4);
						if(%rnd <= 2) %this.movex = 1;
						if(%rnd >= 3) %this.movex = -1;
						if(%rnd != 1 && %rnd != 4) %this.movey = 0;
						else %this.movey = 1;
						%this.moving = true;
					}
				} else {
					if(%this.movey == 0 && getrandom(0,1)) %this.movey = -1;
					if(%this.movey == 1 && getrandom(0,1)) %this.movey = 0;
					if(%this.movey != 0) %this.moving = true;
					else if(%this.movex == 0) %this.moving = false;
				}
			}
			if(!isObject(%brickup)) {
				if(%frontobj == %this.looking && getrandom(1, 30) == 30) %this.jump();
				else if(isobject(%this.looking) && %muzzleobj != %this.looking && getword(%this.looking.getposition(), 2) - 2.3565 > getword(%this.getposition(), 2)) %this.jump();
			}
		case "wander":
			switch(%this.moving) {
					case 0:
						if(getrandom(1,20) == 20) {
							%this.moving = 1;
							%rnd = getrandom(1, 8);
							if(%rnd == 1 || %rnd == 2 || %rnd == 8) %this.movey = 1;
							if(%rnd == 2 || %rnd == 3 || %rnd == 4) %this.movex = 1;
							if(%rnd == 4 || %rnd == 5 || %rnd == 6) %this.movey = -1;
							if(%rnd == 6 || %rnd == 7 || %rnd == 8) %this.movex = -1;
							%rnd = getrandom(0, 1);
							if(%rnd) {
								%this.movex = 0;
							}
							%rnd = getrandom(0, 1);
							if(%rnd) {
								%this.movey = 1;
							}
						}
					case 1:
						if(getrandom(1,30) == 30) {
							%rnd = getrandom(1, 8);
							if(%rnd == 1 || %rnd == 2 || %rnd == 8) %this.movey = 1;
							if(%rnd == 2 || %rnd == 3 || %rnd == 4) %this.movex = 1;
							if(%rnd == 4 || %rnd == 5 || %rnd == 6) %this.movey = -1;
							if(%rnd == 6 || %rnd == 7 || %rnd == 8) %this.movex = -1;
							%rnd = getrandom(0, 1);
							if(%rnd) {
								%this.movex = 0;
							}
							%rnd = getrandom(0, 1);
							if(%rnd) {
								%this.movey = 1;
							}
						} else if(getrandom(1,50) == 50) {
							%this.moving = 0;
							%this.movex = 0;
							%this.movey = 0;
						}
				}
				if(%this.movey != 0) %this.moving = true;
				else if(%this.movex == 0) %this.moving = false;
				if(!%frontobj.team && %this.moving && getdistance(%this, %frontobj) < 5) {
					%vel = %this.getvelocity();
					%x = getword(%vel, 0);
					%y = getword(%vel, 1);
					%z = getword(%vel, 2);
					%vel = msqrt((%x * %x) + (%y * %y) + (%z * %z));
					if(%vel < 2) %this.findrandomdestination(%brickup);
				}
				if(!isObject(%brickup) && ((%this.moving && getrandom(1, 30) == 30) || getrandom(1, 70) == 70)) %this.jump();
		}
}
