datablock fxDTSBrickData (brickBWSpawnData : brickSpawnPointData)
{
	Category = "Special";
    SubCategory = "Bot Wars";
    UiName = "Bot Spawn Brick";
    IconName = "base/client/ui/brickicons/Spawn Point";
};

function setupBWSpawns(%group)
{
	if(!isobject(%group.botteam1spawns)) {
		%group.botteam1spawns = new SimObject() {};
		missioncleanup.add(%group.botteam1spawns);
		%group.botteam2spawns = new SimObject() {};
		missioncleanup.add(%group.botteam2spawns);
	}
	%group.botteam1spawns.brickcount = 0;
	%group.botteam2spawns.brickcount = 0;
	for(%i = 0; %i < %group.getcount(); %i++) {
		%brick = %group.getobject(%i);
		if(%brick.getdatablock().getname() $= "brickBWSpawnData" && %brick.isPlanted) {
			if(%firstcolor $= "") %firstcolor = %brick.colorID;
			if(%brick.colorID == %firstcolor) {
				%group.botteam1spawns.brickcount++;
				%group.botteam1spawns.brick[%group.botteam1spawns.brickcount] = %brick;
			} else {
				if(%secondcolor $= "") %secondcolor = %brick.colorID;
				if(%brick.colorID == %secondcolor) {
					%group.botteam2spawns.brickcount++;
					%group.botteam2spawns.brick[%group.botteam2spawns.brickcount] = %brick;
				}
			}
		}
	}
	if(%group.botteam1spawns.brickcount != 5 || %group.botteam2spawns.brickcount != 5) return %group.botteam1spawns.brickcount SPC %group.botteam2spawns.brickcount;
	return "good";
}