
package botspackage
{
	function projectiledata::oncollisiown(%a, %b, %c, %d, %e, %f, %g)
	{
		//%b.dump();
		Parent::oncollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function minigameCanDamage(%a, %b)
	{
		//This used to word fine but a patch broke it, so now I need to hack it. -_-;
		if(%a.getclassname() $= "AIPlayer" && %b.getclassname() $= "AIPlayer" && %a.minigame == %b.minigame && %a.minigame.weapondamage == true) return true;
		else parent::minigameCanDamage(%a, %b);
	}
	
	function AIPlayer::Damage(%this, %obj, %pos, %dmg, %dmgtype)
	{
		%dmg /= 2;
		%this.lastaggressor = %obj.sourceobject;
		%this.ReactToAggressor(%obj.sourceobject);
		if(%this.armor == 1) %dmg /= 2;
		if(%obj.sourceobject.critchance && getrandom(1, 100) <= %obj.sourceobject.critchance) {
			ServerPlay3D(BWCritHitSound, %pos);
			%dmg *= 2;
		}
		if(%obj.sourceobject.vampiric) {
			%dmg = %obj.sourceobject.getdamagelevel() - (%dmg / 5);
			if(%dmg < 0) %dmg = 0;
			%obj.sourceobject.setdamagelevel(%dmg);
			%obj.sourceobject.emote(loveimage);
		}
		parent::Damage(%this, %obj, %pos, %dmg, %dmgtype);
	}
	
	function AIPlayer::applyBodyParts()
	{
		return;
	}
	
	function AIPlayer::applyBodyColors()
	{
		return;
	}
	
	function ScriptObject::RemoveMember(%this, %member)
	{
		if(%this.botWarsGame) return;
		parent::removemember(%this, %member);
	}
	
	function fXDTSBrick::OnActivate(%brick, %player, %client, %contactPoint, %vector)
	{
		Parent::OnActivate(%brick, %player, %client, %contactPoint, %vector);
		if(%brick.getdatablock().getname() $= "brickBWSpawnData") {
			if(gettrustlevel(%client, %brick) < 2) return;
			%group = getbrickgroupfromobject(%brick);
			switch(%brick.colorID) {
				case 8:
					%brick.setcolor(0);
					%group.team1spawngroup.remove(%brick);
					%group.team2spawngroup.add(%brick);
				case 0:
					%brick.setcolor(33);
					%group.team2spawngroup.remove(%brick);
				default:
					%brick.setcolor(8);
					%group.team1spawngroup.add(%brick);
			}
		}
	}
	
	function paintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function flatPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function pearlPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function chromePaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function glowPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function blinkPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function swirlPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function rainbowPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function stablePaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function jelloPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%c.getdatablock().getname() $= "brickBWSpawnData") return;
		else Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function Observer::onTrigger(%this, %obj, %trig, %press) {
		if(%trig == 0 && %press) {
			%client = %obj.getcontrollingclient();
			%client.observingmember++;
			if(%client.observingmember > $botfightgame.numMembers) %client.observingmember = 0;
			%bot = $botfightgame.member[%client.observingmember];
			%obj.setorbitmode(%bot, "0 0 5 0 0 1 0", 0, 5, 0, 0);
			%client.observedbot = %bot;
		}
		if(!%client.observebots) Parent::onTrigger(%this, %obj, %trig, %press);
	}
	
};
activatePackage(botspackage);