for(%i = 0; %i < clientGroup.getCount(); %i++) if(isObject(clientGroup.getObject(%i).botWarsData)) clientGroup.getObject(%i).botWarsData.delete();

if(ForceRequiredAddOn("Weapon_Bow") == $Error::AddOn_Disabled) {
    error("ERROR: Gamemode_BotWars - required add-on Weapon_Bow not found");
    return;
}
if(ForceRequiredAddOn("Weapon_Gun") == $Error::AddOn_Disabled) {
    error("ERROR: Gamemode_BotWars - required add-on Weapon_Gun not found");
    return;
}
if(ForceRequiredAddOn("Weapon_Guns_Akimbo") == $Error::AddOn_Disabled) {
    error("ERROR: Gamemode_BotWars - required add-on Weapon_Guns_Akimbo not found");
    return;
}
if(ForceRequiredAddOn("Weapon_Rocket_Launcher") == $Error::AddOn_Disabled) {
    error("ERROR: Gamemode_BotWars - required add-on Weapon_Rocket_Launcher not found");
    return;
}
if(ForceRequiredAddOn("Weapon_Sword") == $Error::AddOn_Disabled) {
    error("ERROR: Gamemode_BotWars - required add-on Weapon_Sword not found");
    return;
}

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")) {
	if(!$RTB::RTBR_ServerControl_Hook) exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Non-Admins can start fights","Bot Wars","BotWars::AllowClientGames","bool","Game_BotWars",0,0,0,"BotWarsPrefOnChangeACG");
	RTB_registerPref("Team budget (10k recommended)","Bot Wars","BotWars::Storebudget","int 1000 100000","Game_BotWars",10000,1,0,"BotWarsPrefOnChangeBudget");
	RTB_addInfoTip("More creeper spawns don't make it grow faster! Only plant extras to make the game less predictable.", "", "Creep Mod");
} else {
	$BotWars::AllowClientGames = false; //flag for if starting fights is admin-only
	$BotWars::Store[budget] = 10000;
}

function BotWarsPrefOnChangeACG(%old, %new)
{
	switch(%new) {
		case 1:
			%mode = "Anybody";
		default:
			%mode = "Only admins";
	}
	schedule(10, 0, "messageall", "", "\c3+ Bot Wars: \c5" @ %mode @ " \c0can start bot fights with \"\c6/botfight name1 name2\c0\".");
}

function BotWarsPrefOnChangeBudget(%old, %new)
{
	schedule(10, 0, "messageall", "", "\c3+ Bot Wars: team budget is now \c5$" @ %new @ " \c0(requires server reset).");
}

//TO DO:
//audit code to make sure nothing will explode if one of the players leaves mid-game, and if it will... probably just cancel the game immediately.
//wandering bots are a little too into nearby walls
//random loadout allowed berserker swordsman

exec("./bot wars/package.cs");
exec("./bot wars/bricks.cs");
exec("./bot wars/utilities.cs");
exec("./bot wars/bots.cs");
exec("./bot wars/AI_functions.cs");
exec("./bot wars/AI_thought.cs");
exec("./bot wars/AI_motivations.cs");
exec("./bot wars/game.cs");
exec("./bot wars/servercmds.cs");
exec("./bot wars/GUIsupport.cs");
exec("./bot wars/store.cs");
if(isFile("./bot wars/premiumstore.cs")) exec("./bot wars/premiumstore.cs");